Fold assembler flags into cflags, for consistent behavior
[helenos.git] / tools / toolchain.sh
blob4b9d3a49d093dc7806035656e49cd1fa13e6ee37
1 #! /bin/bash
4 # Copyright (c) 2009 Martin Decky
5 # All rights reserved.
7 # Redistribution and use in source and binary forms, with or without
8 # modification, are permitted provided that the following conditions
9 # are met:
11 # - Redistributions of source code must retain the above copyright
12 # notice, this list of conditions and the following disclaimer.
13 # - Redistributions in binary form must reproduce the above copyright
14 # notice, this list of conditions and the following disclaimer in the
15 # documentation and/or other materials provided with the distribution.
16 # - The name of the author may not be used to endorse or promote products
17 # derived from this software without specific prior written permission.
19 # THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
20 # IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
21 # OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
22 # IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
23 # INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
24 # NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
25 # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
26 # THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
27 # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
28 # THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
31 BINUTILS_GDB_GIT="https://github.com/HelenOS/binutils-gdb.git"
33 BINUTILS_BRANCH="binutils-2_31_1-helenos"
34 BINUTILS_VERSION="2.31.1"
36 GDB_BRANCH="gdb-8_2-helenos"
37 GDB_VERSION="8.2"
39 GCC_GIT="https://github.com/HelenOS/gcc.git"
40 GCC_BRANCH="8_2_0-helenos"
41 GCC_VERSION="8.2.0"
43 BASEDIR="`pwd`"
44 SRCDIR="$(readlink -f $(dirname "$0"))"
46 REAL_INSTALL=true
47 USE_HELENOS_TARGET=true
49 check_error() {
50 if [ "$1" -ne "0" ] ; then
51 echo
52 echo "Script failed: $2"
54 exit 1
58 show_usage() {
59 echo "Cross-compiler toolchain build script"
60 echo
61 echo "Syntax:"
62 echo " $0 [--no-install] [--non-helenos-target] <platform>"
63 echo " $0 --test-version [<platform>]"
64 echo
65 echo "Possible target platforms are:"
66 echo " amd64 AMD64 (x86-64, x64)"
67 echo " arm32 ARM 32b"
68 echo " arm64 AArch64"
69 echo " ia32 IA-32 (x86, i386)"
70 echo " ia64 IA-64 (Itanium)"
71 echo " mips32 MIPS little-endian 32b"
72 echo " mips32eb MIPS big-endian 32b"
73 echo " ppc32 PowerPC 32b"
74 echo " riscv64 RISC-V 64b"
75 echo " sparc64 SPARC V9"
76 echo " all build all targets"
77 echo " essential build only targets currently needed for HelenOS development"
78 echo " parallel same as 'all', but all in parallel"
79 echo " 2-way same as 'all', but 2-way parallel"
80 echo
81 echo "The toolchain is installed into directory specified by the"
82 echo "CROSS_PREFIX environment variable. If the variable is not"
83 echo "defined, /usr/local/cross/ is used as default."
84 echo
85 echo "If --no-install is present, the toolchain still uses the"
86 echo "CROSS_PREFIX as the target directory but the installation"
87 echo "copies the files into PKG/ subdirectory without affecting"
88 echo "the actual root file system. That is only useful if you do"
89 echo "not want to run the script under the super user."
90 echo
91 echo "The --non-helenos-target will build non-HelenOS-specific toolchain"
92 echo "(i.e. it will use *-linux-* triplet instead of *-helenos)."
93 echo "Using this toolchain for building HelenOS is not supported."
94 echo
96 exit 3
99 test_version() {
100 echo "Cross-compiler toolchain build script"
101 echo
102 echo "Start testing the version of the installed software"
103 echo
105 if [ -z "$1" ] || [ "$1" == "all" ] ; then
106 PLATFORMS=("amd64" "arm32" "arm64" "ia32" "ia64" "mips32" "mips32eb" "ppc32" "riscv64" "sparc64")
107 else
108 PLATFORMS=("$1")
112 if [ -z "${CROSS_PREFIX}" ] ; then
113 CROSS_PREFIX="/usr/local/cross"
116 for i in "${PLATFORMS[@]}"
118 PLATFORM="$i"
119 set_target_from_platform "$PLATFORM"
120 PREFIX="${CROSS_PREFIX}/bin/${HELENOS_TARGET}"
122 echo "== $PLATFORM =="
123 test_app_version "Binutils" "ld" "GNU\ ld\ \(GNU\ Binutils\)\ ((\.|[0-9])+)" "$BINUTILS_VERSION"
124 test_app_version "GCC" "gcc" "gcc\ version\ ((\.|[0-9])+)" "$GCC_VERSION"
125 test_app_version "GDB" "gdb" "GNU\ gdb\ \(GDB\)\s+((\.|[0-9])+)" "$GDB_VERSION"
126 done
128 exit
131 test_app_version() {
132 PKGNAME="$1"
133 APPNAME="$2"
134 REGEX="$3"
135 INS_VERSION="$4"
138 APP="${PREFIX}-${APPNAME}"
139 if [ ! -e $APP ]; then
140 echo "- $PKGNAME is missing"
141 else
143 OUT=$(${APP} -v 2>&1)
144 } &> /dev/null
146 if [[ "$OUT" =~ $REGEX ]]; then
147 VERSION="${BASH_REMATCH[1]}"
148 if [ "$INS_VERSION" = "$VERSION" ]; then
149 echo "+ $PKGNAME is uptodate ($INS_VERSION)"
150 else
151 echo "- $PKGNAME ($VERSION) is outdated ($INS_VERSION)"
153 else
154 echo "- $PKGNAME Unexpected output"
161 change_title() {
162 echo -en "\e]0;$1\a"
165 show_countdown() {
166 TM="$1"
168 if [ "${TM}" -eq 0 ] ; then
169 echo
170 return 0
173 echo -n "${TM} "
174 change_title "${TM}"
175 sleep 1
177 TM="`expr "${TM}" - 1`"
178 show_countdown "${TM}"
181 show_dependencies() {
182 echo "IMPORTANT NOTICE:"
183 echo
184 echo "For a successful compilation and use of the cross-compiler"
185 echo "toolchain you need at least the following dependencies."
186 echo
187 echo "Please make sure that the dependencies are present in your"
188 echo "system. Otherwise the compilation process might fail after"
189 echo "a few seconds or minutes."
190 echo
191 echo " - SED, AWK, Flex, Bison, gzip, bzip2, Bourne Shell"
192 echo " - gettext, zlib, Texinfo, libelf, libgomp"
193 echo " - GNU Make, Coreutils, Sharutils, tar"
194 echo " - native C and C++ compiler, assembler and linker"
195 echo " - native C and C++ standard library with headers"
196 echo
199 cleanup_dir() {
200 DIR="$1"
202 if [ -d "${DIR}" ] ; then
203 change_title "Removing ${DIR}"
204 echo " >>> Removing ${DIR}"
205 rm -fr "${DIR}"
209 create_dir() {
210 DIR="$1"
211 DESC="$2"
213 change_title "Creating ${DESC}"
214 echo ">>> Creating ${DESC}"
216 mkdir -p "${DIR}"
217 test -d "${DIR}"
218 check_error $? "Unable to create ${DIR}."
221 check_dirs() {
222 OUTSIDE="$1"
223 BASE="$2"
224 ORIGINAL="`pwd`"
226 mkdir -p "${OUTSIDE}"
228 cd "${OUTSIDE}"
229 check_error $? "Unable to change directory to ${OUTSIDE}."
230 ABS_OUTSIDE="`pwd`"
232 cd "${BASE}"
233 check_error $? "Unable to change directory to ${BASE}."
234 ABS_BASE="`pwd`"
236 cd "${ORIGINAL}"
237 check_error $? "Unable to change directory to ${ORIGINAL}."
239 BASE_LEN="${#ABS_BASE}"
240 OUTSIDE_TRIM="${ABS_OUTSIDE:0:${BASE_LEN}}"
242 if [ "${OUTSIDE_TRIM}" == "${ABS_BASE}" ] ; then
243 echo
244 echo "CROSS_PREFIX cannot reside within the working directory."
246 exit 5
250 prepare() {
251 show_dependencies
252 show_countdown 10
254 mkdir -p "${BASEDIR}/downloads"
255 cd "${BASEDIR}/downloads"
256 check_error $? "Change directory failed."
258 echo ">>> Downloading sources"
259 git clone --depth 1 -b "$BINUTILS_BRANCH" "$BINUTILS_GDB_GIT" "binutils-$BINUTILS_VERSION"
260 git clone --depth 1 -b "$GDB_BRANCH" "$BINUTILS_GDB_GIT" "gdb-$GDB_VERSION"
261 git clone --depth 1 -b "$GCC_BRANCH" "$GCC_GIT" "gcc-$GCC_VERSION"
263 # If the directory already existed, pull upstream changes.
264 git -C "binutils-$BINUTILS_VERSION" pull
265 git -C "gdb-$GDB_VERSION" pull
266 git -C "gcc-$GCC_VERSION" pull
268 echo ">>> Downloading GCC prerequisites"
269 cd "gcc-${GCC_VERSION}"
270 ./contrib/download_prerequisites
271 cd ..
274 set_target_from_platform() {
275 case "$1" in
276 "arm32")
277 GNU_ARCH="arm"
279 "arm64")
280 GNU_ARCH="aarch64"
282 "ia32")
283 GNU_ARCH="i686"
285 "mips32")
286 GNU_ARCH="mipsel"
288 "mips32eb")
289 GNU_ARCH="mips"
291 "ppc32")
292 GNU_ARCH="ppc"
295 GNU_ARCH="$1"
297 esac
299 HELENOS_TARGET="${GNU_ARCH}-helenos"
301 case "$1" in
302 "arm32")
303 LINUX_TARGET="${GNU_ARCH}-linux-gnueabi"
306 LINUX_TARGET="${GNU_ARCH}-linux-gnu"
308 esac
311 build_target() {
312 PLATFORM="$1"
314 # This sets the *_TARGET variables
315 set_target_from_platform "$PLATFORM"
316 if $USE_HELENOS_TARGET ; then
317 TARGET="$HELENOS_TARGET"
318 else
319 TARGET="$LINUX_TARGET"
322 WORKDIR="${BASEDIR}/${TARGET}"
323 INSTALL_DIR="${BASEDIR}/PKG"
324 BINUTILSDIR="${WORKDIR}/binutils-${BINUTILS_VERSION}"
325 GCCDIR="${WORKDIR}/gcc-${GCC_VERSION}"
326 GDBDIR="${WORKDIR}/gdb-${GDB_VERSION}"
328 if [ -z "${CROSS_PREFIX}" ] ; then
329 CROSS_PREFIX="/usr/local/cross"
332 if [ -z "$JOBS" ] ; then
333 JOBS=`nproc`
336 PREFIX="${CROSS_PREFIX}"
338 echo ">>> Removing previous content"
339 cleanup_dir "${WORKDIR}"
340 mkdir -p "${WORKDIR}"
341 check_dirs "${PREFIX}" "${WORKDIR}"
343 if $USE_HELENOS_TARGET ; then
344 echo ">>> Creating build sysroot"
345 mkdir -p "${WORKDIR}/sysroot/include"
346 mkdir "${WORKDIR}/sysroot/lib"
347 cp -r -L -t "${WORKDIR}/sysroot/include" \
348 ${SRCDIR}/../abi/include/* \
349 ${SRCDIR}/../uspace/lib/c/arch/${PLATFORM}/include/* \
350 ${SRCDIR}/../uspace/lib/c/include/*
351 check_error $? "Failed to create build sysroot."
354 echo ">>> Processing binutils (${PLATFORM})"
355 mkdir -p "${BINUTILSDIR}"
356 cd "${BINUTILSDIR}"
357 check_error $? "Change directory failed."
359 change_title "binutils: configure (${PLATFORM})"
360 CFLAGS=-Wno-error "${BASEDIR}/downloads/binutils-${BINUTILS_VERSION}/configure" \
361 "--target=${TARGET}" \
362 "--prefix=${PREFIX}" \
363 "--program-prefix=${TARGET}-" \
364 --disable-nls \
365 --disable-werror \
366 --enable-gold \
367 --enable-deterministic-archives \
368 --disable-gdb \
369 --with-sysroot
370 check_error $? "Error configuring binutils."
372 change_title "binutils: make (${PLATFORM})"
373 make all -j$JOBS
374 check_error $? "Error compiling binutils."
376 change_title "binutils: install (${PLATFORM})"
377 make install "DESTDIR=${INSTALL_DIR}"
378 check_error $? "Error installing binutils."
381 echo ">>> Processing GCC (${PLATFORM})"
382 mkdir -p "${GCCDIR}"
383 cd "${GCCDIR}"
384 check_error $? "Change directory failed."
386 if $USE_HELENOS_TARGET ; then
387 SYSROOT=--with-sysroot --with-build-sysroot="${WORKDIR}/sysroot"
388 else
389 SYSROOT=--without-headers
392 change_title "GCC: configure (${PLATFORM})"
393 PATH="$PATH:${INSTALL_DIR}/${PREFIX}/bin" "${BASEDIR}/downloads/gcc-${GCC_VERSION}/configure" \
394 "--target=${TARGET}" \
395 "--prefix=${PREFIX}" \
396 "--program-prefix=${TARGET}-" \
397 --with-gnu-as \
398 --with-gnu-ld \
399 --disable-nls \
400 --enable-languages=c,c++,go \
401 --enable-lto \
402 --disable-shared \
403 --disable-werror \
404 $SYSROOT
405 check_error $? "Error configuring GCC."
407 change_title "GCC: make (${PLATFORM})"
408 PATH="${PATH}:${PREFIX}/bin:${INSTALL_DIR}/${PREFIX}/bin" make all-gcc -j$JOBS
409 check_error $? "Error compiling GCC."
411 if $USE_HELENOS_TARGET ; then
412 PATH="${PATH}:${PREFIX}/bin:${INSTALL_DIR}/${PREFIX}/bin" make all-target-libgcc -j$JOBS
413 check_error $? "Error compiling libgcc."
414 # TODO: needs some extra care
415 #PATH="${PATH}:${PREFIX}/bin:${INSTALL_DIR}/${PREFIX}/bin" make all-target-libatomic -j$JOBS
416 #check_error $? "Error compiling libatomic."
417 #PATH="${PATH}:${PREFIX}/bin:${INSTALL_DIR}/${PREFIX}/bin" make all-target-libstdc++-v3 -j$JOBS
418 #check_error $? "Error compiling libstdc++."
421 change_title "GCC: install (${PLATFORM})"
422 PATH="${PATH}:${INSTALL_DIR}/${PREFIX}/bin" make install-gcc "DESTDIR=${INSTALL_DIR}"
423 if $USE_HELENOS_TARGET ; then
424 PATH="${PATH}:${INSTALL_DIR}/${PREFIX}/bin" make install-target-libgcc "DESTDIR=${INSTALL_DIR}"
425 #PATH="${PATH}:${INSTALL_DIR}/${PREFIX}/bin" make install-target-libatomic "DESTDIR=${INSTALL_DIR}"
426 #PATH="${PATH}:${INSTALL_DIR}/${PREFIX}/bin" make install-target-libstdc++-v3 "DESTDIR=${INSTALL_DIR}"
428 check_error $? "Error installing GCC."
431 echo ">>> Processing GDB (${PLATFORM})"
432 mkdir -p "${GDBDIR}"
433 cd "${GDBDIR}"
434 check_error $? "Change directory failed."
436 change_title "GDB: configure (${PLATFORM})"
437 PATH="$PATH:${INSTALL_DIR}/${PREFIX}/bin" "${BASEDIR}/downloads/gdb-${GDB_VERSION}/configure" \
438 "--target=${TARGET}" \
439 "--prefix=${PREFIX}" \
440 "--program-prefix=${TARGET}-" \
441 --enable-werror=no
442 check_error $? "Error configuring GDB."
444 change_title "GDB: make (${PLATFORM})"
445 PATH="${PATH}:${PREFIX}/bin:${INSTALL_DIR}/${PREFIX}/bin" make all-gdb -j$JOBS
446 check_error $? "Error compiling GDB."
448 change_title "GDB: make (${PLATFORM})"
449 PATH="${PATH}:${INSTALL_DIR}/${PREFIX}/bin" make install-gdb "DESTDIR=${INSTALL_DIR}"
450 check_error $? "Error installing GDB."
452 # Symlink clang and lld to the install path.
453 CLANG="`which clang 2> /dev/null || echo "/usr/bin/clang"`"
454 LLD="`which ld.lld 2> /dev/null || echo "/usr/bin/ld.lld"`"
456 ln -s $CLANG "${INSTALL_DIR}/${PREFIX}/bin/${TARGET}-clang"
457 ln -s $LLD "${INSTALL_DIR}/${PREFIX}/bin/${TARGET}-ld.lld"
459 if $REAL_INSTALL ; then
460 echo ">>> Moving to the destination directory."
461 echo cp -r -t "${PREFIX}" "${INSTALL_DIR}/${PREFIX}/"*
462 cp -r -t "${PREFIX}" "${INSTALL_DIR}/${PREFIX}/"*
465 cd "${BASEDIR}"
466 check_error $? "Change directory failed."
468 echo ">>> Cleaning up"
469 cleanup_dir "${WORKDIR}"
471 echo
472 echo ">>> Cross-compiler for ${TARGET} installed."
475 while [ "$#" -gt 1 ] ; do
476 case "$1" in
477 --test-version)
478 test_version "$2"
479 exit
481 --no-install)
482 REAL_INSTALL=false
483 shift
485 --non-helenos-target)
486 USE_HELENOS_TARGET=false
487 shift
490 show_usage
492 esac
493 done
495 if [ "$#" -lt "1" ] ; then
496 show_usage
499 case "$1" in
500 --test-version)
501 test_version
503 amd64|arm32|arm64|ia32|ia64|mips32|mips32eb|ppc32|riscv64|sparc64)
504 prepare
505 build_target "$1"
507 "all")
508 prepare
509 build_target "amd64"
510 build_target "arm32"
511 build_target "arm64"
512 build_target "ia32"
513 build_target "ia64"
514 build_target "mips32"
515 build_target "mips32eb"
516 build_target "ppc32"
517 build_target "riscv64"
518 build_target "sparc64"
520 "essential")
521 prepare
522 build_target "amd64"
523 build_target "arm32"
524 build_target "arm64"
525 build_target "ia32"
526 build_target "ia64"
527 build_target "mips32"
528 build_target "mips32eb"
529 build_target "ppc32"
530 build_target "sparc64"
532 "parallel")
533 prepare
534 build_target "amd64" &
535 build_target "arm32" &
536 build_target "arm64" &
537 build_target "ia32" &
538 build_target "ia64" &
539 build_target "mips32" &
540 build_target "mips32eb" &
541 build_target "ppc32" &
542 build_target "riscv64" &
543 build_target "sparc64" &
544 wait
546 "2-way")
547 prepare
548 build_target "amd64" &
549 build_target "arm32" &
550 wait
552 build_target "arm64" &
553 build_target "ia32" &
554 wait
556 build_target "ia64" &
557 build_target "mips32" &
558 wait
560 build_target "mips32eb" &
561 build_target "ppc32" &
562 wait
564 build_target "riscv64" &
565 build_target "sparc64" &
566 wait
569 show_usage
571 esac